﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Windows.Media;

namespace XamGridSample
{
	public class DataSource
	{
		static DataSource()
		{
			PersonColors = new List<PersonColor> {
			                                     	new PersonColor {Id = 1, Color = Colors.DimGray},
			                                     	new PersonColor {Id = 2, Color = Colors.Green},
			                                     	new PersonColor {Id = 3, Color = Colors.LightSkyBlue},
			                                     	new PersonColor {Id = 4, Color = Colors.Olive},
			                                     	new PersonColor {Id = 5, Color = Colors.Yellow}
			                                     };

			Persons =
				new BindingList<Person>(new List<Person> {
				                                         	new Person {Age = 25, ColorId = 2, FirstName = "John", JoinDate = DateTime.Parse("2011-12-13"), LastName = "Cooper"},
				                                         	new Person {Age = 25, ColorId = 3, FirstName = "Armen", JoinDate = DateTime.Parse("2011-02-10"), LastName = "Traver"},
				                                         	new Person {Age = 40, ColorId = 1, FirstName = "Alexander", JoinDate = DateTime.Parse("2011-02-25"), LastName = "Baranov"},
				                                         	new Person {Age = 40, ColorId = 1, FirstName = "Sebastian", JoinDate = DateTime.Parse("2011-11-01"), LastName = "Moore"},
				                                         	new Person {Age = 40, ColorId = 5, FirstName = "Machael", JoinDate = DateTime.Parse("2011-07-29"), LastName = "Pluess"}
				                                         });
		}

		public static BindingList<Person> Persons { get; private set; }

		public static List<PersonColor> PersonColors { get; private set; }
	}

	public class Person
	{
		public string FirstName { get; set; }
		public string LastName { get; set; }
		public int Age { get; set; }
		public DateTime JoinDate { get; set; }
		public int ColorId { get; set; }

		public Color Color
		{
			get { return DataSource.PersonColors.Where(c => c.Id == ColorId).Select(c => c.Color).FirstOrDefault(); }
		}

		public string Whatever { get; set; }
	}

	public class PersonColor
	{
		public int Id { get; set; }
		public Color Color { get; set; }
	}
}